#include <avr/io.h>

#include "adc.h"

/* ADC init */
void adc_init(void)
{
  // dummy variable
  static volatile uint16_t dummy;

  // set the reference voltage
  ADMUX = ( 0 << REFS1 ) | ( 1 << REFS0 );

  // set the prescaler
  ADCSRA = (0 << ADPS2 ) | ( 1 << ADPS1 ) | ( 1 << ADPS0 );

  // enable the ADC
  ADCSRA |= ( 1 << ADEN );                  // ADC aktivieren

  // perform a dummy conversion and wait for the result
  ADCSRA |= ( 1 << ADSC );
  while (ADCSRA & ( 1 << ADSC ) ) {
  }
  /* dummy read to set everything up correctly */
  dummy = ADCW;
}

/* ADC single conversion */
uint16_t adc_read( uint8_t channel )
{
  // select channel
  ADMUX = ( ADMUX & ~( 0x1F ) ) | ( channel & 0x1F );
  ADCSRA |= ( 1 << ADSC );            // single conversion
  while ( ADCSRA & ( 1 << ADSC ) ) {  // wait for result
  }
  return ADCW;                    // return result
}
